/*
 * file: XxLcdAlphaDigit.cpp
 *
 * This file is part of the XxWinLib library which is developed to support
 * the development of NetStreamer. This file is distributed under the
 * GNU GENERAL PUBLIC LICENSE, see the accompanying COPYING file.
 *
 * Copyright (C) 1997 Rolf Fokkens
 *
 * Rel  When   who  What
 * 0.9  980104 Rolf Removed bug in XxLcdNumDigit: bad arraysize for DigitBitmaps
 */

#include "XxLcdAlphaDigit.h"
#include "XxBitmap.h"
#include "XxPixmap.h"

#include "XxLcdAlphaDigitBack.xbm"
#include "XxLcdAlphaDigit0x20.xbm" // " " 
#include "XxLcdAlphaDigit0.xbm"
#include "XxLcdAlphaDigit1.xbm"
#include "XxLcdAlphaDigit2.xbm"
#include "XxLcdAlphaDigit3.xbm"
#include "XxLcdAlphaDigit4.xbm"
#include "XxLcdAlphaDigit5.xbm"
#include "XxLcdAlphaDigit6.xbm"
#include "XxLcdAlphaDigit7.xbm"
#include "XxLcdAlphaDigit8.xbm"
#include "XxLcdAlphaDigit9.xbm"
#include "XxLcdAlphaDigit0x3a.xbm" // ":" 
#include "XxLcdAlphaDigitA.xbm"
#include "XxLcdAlphaDigitB.xbm"
#include "XxLcdAlphaDigitC.xbm"
#include "XxLcdAlphaDigitD.xbm"
#include "XxLcdAlphaDigitE.xbm"
#include "XxLcdAlphaDigitF.xbm"
#include "XxLcdAlphaDigitG.xbm"
#include "XxLcdAlphaDigitH.xbm"
#include "XxLcdAlphaDigitI.xbm"
#include "XxLcdAlphaDigitJ.xbm"
#include "XxLcdAlphaDigitK.xbm"
#include "XxLcdAlphaDigitL.xbm"
#include "XxLcdAlphaDigitM.xbm"
#include "XxLcdAlphaDigitN.xbm"
#include "XxLcdAlphaDigitO.xbm"
#include "XxLcdAlphaDigitP.xbm"
#include "XxLcdAlphaDigitQ.xbm"
#include "XxLcdAlphaDigitR.xbm"
#include "XxLcdAlphaDigitS.xbm"
#include "XxLcdAlphaDigitT.xbm"
#include "XxLcdAlphaDigitU.xbm"
#include "XxLcdAlphaDigitV.xbm"
#include "XxLcdAlphaDigitW.xbm"
#include "XxLcdAlphaDigitX.xbm"
#include "XxLcdAlphaDigitY.xbm"
#include "XxLcdAlphaDigitZ.xbm"
#include "XxLcdAlphaDigita.xbm"
#include "XxLcdAlphaDigitb.xbm"
#include "XxLcdAlphaDigitc.xbm"
#include "XxLcdAlphaDigitd.xbm"
#include "XxLcdAlphaDigite.xbm"
#include "XxLcdAlphaDigitf.xbm"
#include "XxLcdAlphaDigitg.xbm"
#include "XxLcdAlphaDigith.xbm"
#include "XxLcdAlphaDigiti.xbm"
#include "XxLcdAlphaDigitj.xbm"
#include "XxLcdAlphaDigitk.xbm"
#include "XxLcdAlphaDigitl.xbm"
#include "XxLcdAlphaDigitm.xbm"
#include "XxLcdAlphaDigitn.xbm"
#include "XxLcdAlphaDigito.xbm"
#include "XxLcdAlphaDigitp.xbm"
#include "XxLcdAlphaDigitq.xbm"
#include "XxLcdAlphaDigitr.xbm"
#include "XxLcdAlphaDigits.xbm"
#include "XxLcdAlphaDigitt.xbm"
#include "XxLcdAlphaDigitu.xbm"
#include "XxLcdAlphaDigitv.xbm"
#include "XxLcdAlphaDigitw.xbm"
#include "XxLcdAlphaDigitx.xbm"
#include "XxLcdAlphaDigity.xbm"
#include "XxLcdAlphaDigitz.xbm"

#include "XxLcdNumDot.xbm"

struct BitmapStruct {
    int Width, Height;
    char *Data;
};

#define BMStruct(X) \
{XxLcdAlphaDigit ## X ## _width,  XxLcdAlphaDigit ## A ## _height, \
 XxLcdAlphaDigit ## X ## _bits}

static BitmapStruct BitMapData [] = {
    BMStruct (Back), BMStruct (0x20)
,   BMStruct (0), BMStruct (1), BMStruct (2), BMStruct (3), BMStruct (4)
,   BMStruct (5), BMStruct (6), BMStruct (7), BMStruct (8), BMStruct (9)
,   BMStruct (0x3a)
,   BMStruct (A), BMStruct (B), BMStruct (C), BMStruct (D), BMStruct (E)
,   BMStruct (F), BMStruct (G), BMStruct (H), BMStruct (I), BMStruct (J)
,   BMStruct (K), BMStruct (L), BMStruct (M), BMStruct (N), BMStruct (O)
,   BMStruct (P), BMStruct (Q), BMStruct (R), BMStruct (S), BMStruct (T)
,   BMStruct (U), BMStruct (V), BMStruct (W), BMStruct (X), BMStruct (Y)
,   BMStruct (Z)
,   BMStruct (a), BMStruct (b), BMStruct (c), BMStruct (d), BMStruct (e)
,   BMStruct (f), BMStruct (g), BMStruct (h), BMStruct (i), BMStruct (j)
,   BMStruct (k), BMStruct (l), BMStruct (m), BMStruct (n), BMStruct (o)
,   BMStruct (p), BMStruct (q), BMStruct (r), BMStruct (s), BMStruct (t)
,   BMStruct (u), BMStruct (v), BMStruct (w), BMStruct (x), BMStruct (y)
,   BMStruct (z)
};

#define NR_BITMAPS (int (sizeof(BitMapData) / sizeof (BitmapStruct)))

static int DigitCount = 0;

static XxPixmap *pTempPixmap;

static XxBitmap *DigitBitmaps[NR_BITMAPS];

static void InitDigitBitmaps (void)
{
    int i;
    BitmapStruct *pBD;

    pTempPixmap = new XxPixmap
        ("AlphaTemp", XxLcdAlphaDigitBack_width, XxLcdAlphaDigitBack_height);

    for (i = 0, pBD = BitMapData; i < NR_BITMAPS; i++, pBD++) {
        DigitBitmaps [i]
            = new XxBitmap
                  ( EzString ("AlphaDigitMaps_") + EzString (i)
                  , pBD->Width, pBD->Height, pBD->Data
                  );
    };
};

XxLcdAlphaDigit::XxLcdAlphaDigit
    ( EzString Name
    , XxDrawable *pParent
    , int XOffset, int YOffset
    , XxColor OnColor, XxColor OffColor
    )
    : XxVirtual (Name, pParent, XOffset, YOffset, 23, 29)
{
    if (DigitCount++ == 0) InitDigitBitmaps ();

    XxLcdAlphaDigit::CharVal   = -1;
    XxLcdAlphaDigit::OnColor    = OnColor;
    XxLcdAlphaDigit::OffColor   = OffColor;

    DrawDigit (0);

#   ifdef CRE_TRACE
    printf ("Create XxLcdAlphaDigit %d\n", Pm);
#   endif

};

XxLcdAlphaDigit::~XxLcdAlphaDigit (void)
{
    int i;

    if (--DigitCount != 0) return;

    for (i = 0; i < NR_BITMAPS; i++) {
        delete DigitBitmaps [i];
    };

    delete pTempPixmap;
};

void XxLcdAlphaDigit::DrawDigit (int CharVal)
{
    if (XxLcdAlphaDigit::CharVal == CharVal) return;

    XxLcdAlphaDigit::CharVal = CharVal;

    pTempPixmap->CopyArea (DrawGC, this, 0, 0, GetWidth (), GetHeight (), 0, 0);

    DrawGC.SetForeground (OffColor);
    DrawGC.SetClipMask   (0, 0, DigitBitmaps [0]);
    pTempPixmap->FillRectangle (DrawGC, 0, 0, GetWidth (), GetHeight ());

    if (CharVal != -1) {
        DrawGC.SetForeground (OnColor);
        DrawGC.SetClipMask   (0, 0, DigitBitmaps [CharVal]);
        pTempPixmap->FillRectangle (DrawGC, 0, 0, GetWidth (), GetHeight ());
    };

    DrawGC.SetClipMask   (0, 0, NULL);

    CopyArea (DrawGC, pTempPixmap, 0, 0, GetWidth (), GetHeight (), 0, 0);
};

int XxLcdAlphaDigit::GetNetWidth ()
{
    return 18;
};

void XxLcdAlphaDigit::SetVal (int Val)
{
    if (Val == ' ') {
        Val = 1;
    } else {
        if (Val >= '0' && Val <= 0x3a) {
            Val -= ('0' - 2);
        } else if (Val >= 'A' && Val <= 'Z') {
            Val -= ('A' - 13);
        } else if (Val >= 'a' && Val <= 'z') {
            Val -= ('a' - 13 - 26);
        } else {
            Val = 1;
        }
    };
    if (Val < 1)          Val = 1;
    if (Val > NR_BITMAPS) Val = 1;

    DrawDigit (Val);
};
